(define (scheme2c exp)
  (cond ((null? exp)
			"sc->NIL")
		  ((equal? exp #t)
			"sc->T")
		  ((equal? exp #f)
			"sc->F")
		  ((pair? exp)
			(string-append "cons( sc, "
								(scheme2c (car exp))
								", "
								(scheme2c (cdr exp))
								" )"))
		  ((symbol? exp)
			(string-append "mk_symbol( sc, \""
								(symbol->string exp)
								"\" )"))
		  ((string? exp)
			(string-append "mk_string( sc, \""
								exp
								"\" )"))
		  ((number? exp)
			(string-append "mk_integer( sc, "
								(number->string exp)
								" )"))
		  (else
			(newline)
			(newline)
			(newline)
			(display "Unknown object in schemix-init.scm: ")
			(write exp)
			(newline)
			(newline)
			(newline)
			"UNKNOWN OBJECT")))

(define (parse-input x)
  (cond ((eof-object? x)
			#t)
		  ((and (list? x)
				  (equal? (car x) 'define)
				  (not (null? (cdr x)))
				  (not (null? (cddr x))))
			(cond ((symbol? (cadr x))
					 (display "/* Definition of ")
					 (display (cadr x))
					 (display " */")
					 (newline)
					 (display "define( sc, sc->global_env, ")
					 (display (scheme2c (cadr x)))
					 (display ", ")
					 (display (scheme2c (caddr x)))
					 (display " );")
					 (newline)
					 (newline)
					 (parse-input (read)))
					((pair? (cadr x))
					 (parse-input
					  `(define ,(caadr x) (lambda ,(cdadr x) ,@(cddr x)))))))
		  (else
			(display "/* Evaluation of ")
			(write x)
			(display " */")
			(newline)
			(display "eval( sc, ")
			(display (scheme2c x))
			(display " );")
			(newline)
			(newline)
			(parse-input (read)))))

(with-output-to-file "schemix-init.c"
  (lambda ()
    (with-input-from-file "schemix-init.scm"
      (lambda ()
		  (display "/* THIS FILE WAS AUTOGENERATED FROM schemix-init.scm")
		  (newline)
		  (display "   BY THE 'schemix-make-init' PROGRAM")
		  (newline)
		  (display "   YOU SHOULD NOT EDIT IT BY HAND!")
		  (newline)
		  (newline)
		  (display "   To regenerate this file from its source, you should")
		  (newline)
		  (display "   run the schemix-make-init program.")
		  (newline)
		  (display "   On most systems you can do this by typing")
		  (newline)
		  (display "   'scheme' at a bash prompt and then typing")
		  (newline)
		  (display "   '(load \"schemix-make-init.scm\")'")
		  (newline)
		  (display "   at the scheme prompt. */")
		  (newline)
		  (newline)
		  (newline)
		  (newline)
		  (parse-input (read))))))
